package com.tashow.cloud.product.service.impl;

import com.tashow.cloud.productapi.api.product.dto.ProdEmergencyResponseIntervalsDO;
import com.tashow.cloud.product.mapper.ProdEmergencyResponseIntervalsMapper;
import com.tashow.cloud.product.service.ProdEmergencyResponseIntervalsService;
import com.tashow.cloud.productapi.api.product.vo.prodemergencyresponseintervals.ProdEmergencyResponseIntervalsPageReqVO;
import com.tashow.cloud.productapi.api.product.vo.prodemergencyresponseintervals.ProdEmergencyResponseIntervalsSaveReqVO;
import com.tashow.cloud.productapi.enums.ErrorCodeConstants;
import org.springframework.stereotype.Service;
import jakarta.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;
import com.tashow.cloud.common.pojo.PageResult;
import com.tashow.cloud.common.pojo.PageParam;
import com.tashow.cloud.common.util.object.BeanUtils;


import static com.tashow.cloud.common.exception.util.ServiceExceptionUtil.exception;

/**
 * 紧急响应时间区间设置 Service 实现类
 *
 * @author 芋道源码
 */
@Service
@Validated
public class ProdEmergencyResponseIntervalsServiceImpl implements ProdEmergencyResponseIntervalsService {

    @Resource
    private ProdEmergencyResponseIntervalsMapper prodEmergencyResponseIntervalsMapper;

    @Override
    public Long createProdEmergencyResponseIntervals(ProdEmergencyResponseIntervalsSaveReqVO createReqVO) {
        // 插入
        ProdEmergencyResponseIntervalsDO prodEmergencyResponseIntervals = BeanUtils.toBean(createReqVO, ProdEmergencyResponseIntervalsDO.class);
        prodEmergencyResponseIntervalsMapper.insert(prodEmergencyResponseIntervals);
        // 返回
        return prodEmergencyResponseIntervals.getId();
    }

    @Override
    public void updateProdEmergencyResponseIntervals(ProdEmergencyResponseIntervalsSaveReqVO updateReqVO) {
        // 校验存在
        validateProdEmergencyResponseIntervalsExists(updateReqVO.getId());
        // 更新
        ProdEmergencyResponseIntervalsDO updateObj = BeanUtils.toBean(updateReqVO, ProdEmergencyResponseIntervalsDO.class);
        prodEmergencyResponseIntervalsMapper.updateById(updateObj);
    }

    @Override
    public void deleteProdEmergencyResponseIntervals(Long id) {
        // 校验存在
        validateProdEmergencyResponseIntervalsExists(id);
        // 删除
        prodEmergencyResponseIntervalsMapper.deleteById(id);
    }

    private void validateProdEmergencyResponseIntervalsExists(Long id) {
        if (prodEmergencyResponseIntervalsMapper.selectById(id) == null) {
            throw exception(ErrorCodeConstants.PROD_EMERGENCY_RESPONSE_INTERVALS_NOT_EXISTS);
        }
    }

    @Override
    public ProdEmergencyResponseIntervalsDO getProdEmergencyResponseIntervals(Long id) {
        return prodEmergencyResponseIntervalsMapper.selectById(id);
    }

    @Override
    public PageResult<ProdEmergencyResponseIntervalsDO> getProdEmergencyResponseIntervalsPage(ProdEmergencyResponseIntervalsPageReqVO pageReqVO) {
        return null;
    }

}